'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _neoBlockchainCore = require('neo-blockchain-core');

var _NetworkAddress = require('./NetworkAddress');

var _NetworkAddress2 = _interopRequireDefault(_NetworkAddress);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let AddrPayload = class AddrPayload {

  constructor({
    addresses
  }) {
    this.serializeWire = (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this));

    this.addresses = addresses;
  }

  serializeWireBase(writer) {
    writer.writeArray(this.addresses, address => address.serializeWireBase(writer));
  }

  static deserializeWireBase(options) {
    const { reader } = options;
    const addresses = reader.readArray(() => _NetworkAddress2.default.deserializeWireBase(options));

    return new this({ addresses });
  }

  static deserializeWire(options) {
    return this.deserializeWireBase({
      context: options.context,
      reader: new _neoBlockchainCore.BinaryReader(options.buffer)
    });
  }
};
exports.default = AddrPayload;