'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _neoBlockchainCore = require('neo-blockchain-core');

let GetBlocksPayload = class GetBlocksPayload {

  constructor({
    hashStart,
    hashStop
  }) {
    this.serializeWire = (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this));

    this.hashStart = hashStart;
    this.hashStop = hashStop || _neoBlockchainCore.common.ZERO_UINT256;
  }

  serializeWireBase(writer) {
    writer.writeArray(this.hashStart, value => {
      writer.writeUInt256(value);
    });
    writer.writeUInt256(this.hashStop);
  }

  static deserializeWireBase({ reader }) {
    const hashStart = reader.readArray(() => reader.readUInt256());
    const hashStop = reader.readUInt256();
    return new this({ hashStart, hashStop });
  }

  static deserializeWire(options) {
    return this.deserializeWireBase({
      context: options.context,
      reader: new _neoBlockchainCore.BinaryReader(options.buffer)
    });
  }
};
exports.default = GetBlocksPayload;