'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _neoBlockchainCore = require('neo-blockchain-core');

let HeadersPayload = class HeadersPayload {

  constructor({
    headers
  }) {
    this.serializeWire = (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this));

    this.headers = headers;
  }

  serializeWireBase(writer) {
    writer.writeArray(this.headers, header => header.serializeWireBase(writer));
  }

  static deserializeWireBase(options) {
    const { reader } = options;
    const headers = reader.readArray(() => _neoBlockchainCore.Header.deserializeWireBase(options));

    return new this({ headers });
  }

  static deserializeWire(options) {
    return this.deserializeWireBase({
      context: options.context,
      reader: new _neoBlockchainCore.BinaryReader(options.buffer)
    });
  }
};
exports.default = HeadersPayload;