'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _neoBlockchainCore = require('neo-blockchain-core');

var _InventoryType = require('./InventoryType');

let InvPayload = class InvPayload {

  constructor({
    type,
    hashes
  }) {
    this.serializeWire = (0, _neoBlockchainCore.createSerializeWire)(this.serializeWireBase.bind(this));

    this.type = type;
    this.hashes = hashes;
  }

  serializeWireBase(writer) {
    writer.writeUInt8(this.type);
    writer.writeArray(this.hashes, value => {
      writer.writeUInt256(value);
    });
  }

  static deserializeWireBase({ reader }) {
    const type = (0, _InventoryType.assertInventoryType)(reader.readUInt8());
    const hashes = reader.readArray(() => reader.readUInt256());
    return new this({ type, hashes });
  }

  static deserializeWire(options) {
    return this.deserializeWireBase({
      context: options.context,
      reader: new _neoBlockchainCore.BinaryReader(options.buffer)
    });
  }
};
exports.default = InvPayload;