"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
const INVENTORY_TYPE = exports.INVENTORY_TYPE = {
  TRANSACTION: 0x01,
  BLOCK: 0x02,
  CONSENSUS: 0xe0
};
let InvalidInventoryTypeError = exports.InvalidInventoryTypeError = class InvalidInventoryTypeError extends Error {

  constructor(inventoryType) {
    super(`Expected inventory type, found: ${inventoryType}`);
    this.inventoryType = inventoryType;
  }
};
const assertInventoryType = exports.assertInventoryType = inventoryType => {
  switch (inventoryType) {
    case INVENTORY_TYPE.TRANSACTION:
      return INVENTORY_TYPE.TRANSACTION;
    case INVENTORY_TYPE.BLOCK:
      return INVENTORY_TYPE.BLOCK;
    case INVENTORY_TYPE.CONSENSUS:
      return INVENTORY_TYPE.CONSENSUS;
    default:
      throw new InvalidInventoryTypeError(inventoryType);
  }
};